package be.jeffcheasey88.peeratcode.parser.state;

import java.util.function.Function;

import be.jeffcheasey88.peeratcode.parser.Bag;
import be.jeffcheasey88.peeratcode.parser.TokenValidator;

public class RedirectStateTree<E, T extends E> extends StateTree<T>{
	
	private StateTree<E> redirect;
	private Function<Bag, String> group;

	public RedirectStateTree(StateTree<E> redirect, Function<Bag, String> group){
		super();
		this.redirect = redirect;
		this.group = group;
	}
	
	@Override
	<B> B internalSeed(TokenValidator validator, T element){
		Bag currentBag = validator.getBag();
		Bag localBag = new Bag();
		
		String g = group.apply(currentBag);
		localBag.addPath(currentBag.path()+"/"+g);
		System.out.println("redirect "+localBag.path());
		currentBag.set(g, localBag);
		validator.setBag(localBag);
		
		TokenValidator branch = validator.branch();
		branch.validate((t) -> {
			System.out.println(t);
			return false;
		});
		Object builded = redirect.internalSeed(branch, (E) element);
		System.out.println("redirect "+localBag.path()+" builded "+builded);
		if(builded == null) return null;
		
		validator.merge(branch);
		validator.setBag(currentBag);
		
		return super.internalSeed(validator, element);
	}
}

